#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SceneCFG.h"
std::auto_ptr<Fish_SceneCFG> Fish_SceneCFG::msSingleton(nullptr);

int Fish_SceneCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SceneCFGData* Fish_SceneCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SceneCFGData>& Fish_SceneCFG::GetMapData()
{
	return mMapData;
}

void Fish_SceneCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SceneCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SceneCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mResName = element->Attribute("ResName");
		data.mResPath = element->Attribute("ResPath");
		{
			const char* PreloadResource = element->Attribute("PreloadResource");
			std::vector<std::string> vecPreloadResource;
			boost::split(vecPreloadResource, PreloadResource, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecPreloadResource.size(); i++)
			{
				data.mPreloadResource.push_back(vecPreloadResource[i]);
			}
		}
		data.mIsSpecial = element->BoolAttribute("IsSpecial");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SceneCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SceneCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SceneCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SceneCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SceneCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "ResName", data.mResName);
		LuaCfgHelper::readString(L, "ResPath", data.mResPath);
		LuaCfgHelper::readVectorString(L, "PreloadResource", data.mPreloadResource);
		LuaCfgHelper::readBool(L, "IsSpecial", data.mIsSpecial);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SceneCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SceneCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SceneCFG* Fish_SceneCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SceneCFG());
	}
	return msSingleton.get();
}

void Fish_SceneCFG::Release()
{
	msSingleton.reset(nullptr);
}
